using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Excel = Microsoft.Office.Interop.Excel;
using System.Windows.Forms;

namespace ExcelDynamicControls
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("90B31F9E-3E02-4810-8BB9-1201B4C35218"), ProgId("ExcelDynamicControls.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXCommandBar myMenu;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.myMenu = new AddinExpress.MSO.ADXCommandBar(this.components);
			// 
			// myMenu
			// 
			this.myMenu.CommandBarName = "My Menu";
			this.myMenu.CommandBarTag = "6ef76a5a-fb05-4c20-94ab-b06229e316c0";
			this.myMenu.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.myMenu.UpdateCounter = 6;
			// 
			// AddinModule
			// 
			this.AddinName = "ExcelDynamicControls";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
			this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);

		}
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private AddinExpress.MSO.ADXCommandBarControl AddControl(object container, Type ctrlType, string caption, 
			string controlTag, int before, bool beginGroup, object eventHandler, bool temporary)
		{
			AddinExpress.MSO.ADXCommandBarControl adxNewControl = null;
			AddinExpress.MSO.ADXBaseControlCollection collection = null;
			
			if (container is AddinExpress.MSO.ADXCommandBar)
				collection = (container as AddinExpress.MSO.ADXCommandBar).Controls;
			else if (container is AddinExpress.MSO.ADXCommandBarPopup)
				collection = (container as AddinExpress.MSO.ADXCommandBarPopup).Controls;
			
			if (collection == null) return null;

			if (eventHandler != null)
			{
				adxNewControl = collection.GetControlByControlTag(controlTag, false);
				if (adxNewControl != null)
				{
					switch(ctrlType.Name)
					{
						case "ADXCommandBarButton":
							adxNewControl.AsButton.Click -= (eventHandler as AddinExpress.MSO.ADXClick_EventHandler);
							break;
						case "ADXCommandBarComboBox":
							adxNewControl.AsComboBox.Change -= (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
							break;
						case "ADXCommandBarDropDownList":
							adxNewControl.AsDropDownList.Change -= (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
							break;
						case "ADXCommandBarEdit":
							adxNewControl.AsEdit.Change -= (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
							break;
					}
				}
			}

			adxNewControl = collection.Add(ctrlType, controlTag, 1, before, temporary);
			adxNewControl.BeginGroup = beginGroup;
			adxNewControl.Caption = caption;
			switch(ctrlType.Name)
			{
				case "ADXCommandBarButton":
					adxNewControl.AsButton.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonCaption;
					if (eventHandler != null)
						adxNewControl.AsButton.Click += (eventHandler as AddinExpress.MSO.ADXClick_EventHandler);
					break;
				case "ADXCommandBarComboBox":
					if (eventHandler != null)
						adxNewControl.AsComboBox.Change += (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
					break;
				case "ADXCommandBarDropDownList":
					if (eventHandler != null)
						adxNewControl.AsDropDownList.Change += (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
					break;
				case "ADXCommandBarEdit":
					if (eventHandler != null)
						adxNewControl.AsEdit.Change += (eventHandler as AddinExpress.MSO.ADXChange_EventHandler);
					break;
				case "ADXCommandBarPopup":
					break;
			}
			return adxNewControl;
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			AddinExpress.MSO.ADXCommandBarControl ctrl;

			AddControl(myMenu, typeof(AddinExpress.MSO.ADXCommandBarButton),
				"My Action", "MY_UNIQUE_TAG 1", 0, true, new AddinExpress.MSO.ADXClick_EventHandler(DoClick), false);
			AddControl(myMenu, typeof(AddinExpress.MSO.ADXCommandBarEdit),
				"", "MY_UNIQUE_TAG 2", 0, true, new AddinExpress.MSO.ADXChange_EventHandler(DoChange), false);

			ctrl = AddControl(myMenu, typeof(AddinExpress.MSO.ADXCommandBarPopup),
				"My Popup Menu", "MY_UNIQUE_TAG 3", 0, false, null, false);
			AddControl(ctrl, typeof(AddinExpress.MSO.ADXCommandBarButton),
				"Popup Item 1", "MY_UNIQUE_TAG 4", 0, false, new AddinExpress.MSO.ADXClick_EventHandler(DoClick), false);
			AddControl(ctrl, typeof(AddinExpress.MSO.ADXCommandBarButton),
				"Popup Item 2", "MY_UNIQUE_TAG 5", 0, false, new AddinExpress.MSO.ADXClick_EventHandler(DoClick), false);
			AddControl(ctrl, typeof(AddinExpress.MSO.ADXCommandBarButton),
				"Popup Item 3", "MY_UNIQUE_TAG 6", 0, false, new AddinExpress.MSO.ADXClick_EventHandler(DoClick), false);

			AddControl(myMenu, typeof(AddinExpress.MSO.ADXCommandBarButton),
				"Clear Popup", "MY_UNIQUE_TAG 7", 0, true, new AddinExpress.MSO.ADXClick_EventHandler(DoClear), false);
		}

		private void AddinModule_AddinBeginShutdown(object sender, System.EventArgs e)
		{
			//
		}

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

		private void DoClick(object sender)
		{
			MessageBox.Show((sender as AddinExpress.MSO.ADXCommandBarControl).Caption, AddinName);
		}
	
		private void DoChange(object sender)
		{
			MessageBox.Show("The Text has been changed.", AddinName);
		}
	
		private void DoClear(object sender)
		{
			AddinExpress.MSO.ADXCommandBarPopup popup =
				myMenu.Controls.GetControlByControlTag("MY_UNIQUE_TAG 3", false) as AddinExpress.MSO.ADXCommandBarPopup;
			if (popup != null)
			{
				popup.Controls.Clear();
			}
		}
	}
}

